
#!/bin/sh 
#Project: VP330
#Firmware upgrade script (update the new firmware)
#Note: Put script in system  /matrix/upgrade folder
#Author: Shailesh Panchal

FIRMWAR_UPGRADE_LOG_DIR=/matrix
FIRMWAR_UPGRADE_DIR=/mnt

echo "Firmware script /dev/mtd5 and echo changed erase Removed"

rm -rf FIRMWAR_UPGRADE_LOG_DIR/firmwarelog

mount -t jffs2 /dev/mtdblock8 /matrix/config

sleep 3

cd $FIRMWAR_UPGRADE_DIR/upgrade

ls -l

#run startup.sh
if [ -f startup.sh ]
then
	chmod 755 ./startup.sh
	./startup.sh
fi

#run update Env variable
if [ ! -f /usr/bin/setUbootEnv.txt ]
then
    if [ ! -f /matrix/config/ProductionTestReport/setUbootEnv.txt ]
    then
        mkdir -p /matrix/config/ProductionTestReport
        
	chmod 755 $FIRMWAR_UPGRADE_DIR/upgrade/setUbootEnv
	$FIRMWAR_UPGRADE_DIR/upgrade/setUbootEnv &
	while [ 1 ];
	do 
	  sleep 1
	done
    fi
fi

application=0
kernel=0
#verify the md5sum of each file
if [ -f appl.jffs2 ]
then
	MD5RESULT=''
	if [ -f appl_md5 ]
	then
		md5sum -c appl_md5 > md5result
		MD5RESULT=`cat md5result | awk '{print $2}'`
	fi
	if [ ! "$MD5RESULT" = "OK" ]
	then
	echo "APPL_MD5_NOT_VALID"
	else
		application=1
	fi
else
echo "APPL_NOT_PRESENT"
fi
sleep 5
if [ -f ram_zimage.bin ]
then
	MD5RESULT=''
	if [ -f kernel_md5 ]
	then
		md5sum -c kernel_md5 > md5result
		MD5RESULT=`cat md5result | awk '{print $2}'`
	fi
	if [ ! "$MD5RESULT" = "OK" ]
	then
	echo "KERNEL_MD5_NOT_VALID"
	else
		kernel=1
	fi
else
echo "KERNEL_NOT_PRESENT"
fi
sleep 5
#update one by one

if [ $application == 1 ]
then
	# Remove Server Configuration to ReSync All Files from Master during Next Poweron.
	rm /matrix/config/ExtendedSipPhone/serverMacAddr.cnfg
	#remount as read write mode
	umount -r /matrix
	#wait for jffs2 thread stop
	sleep 5
	# erase current image from partition
	flash_erase /dev/mtd6 0 160
	#copy image to flash partition
	nandwrite -p /dev/mtd6 $FIRMWAR_UPGRADE_DIR/upgrade/appl.jffs2

	# Remove permission file so that on Next Power on Again Permistion will set properly
	rm /etc/permission

	echo "successfully update Application"

	rm -rf $FIRMWAR_UPGRADE_DIR/upgrade/appl.jffs2
fi
sleep 5
#update kernel
if [ $kernel == 1 ]
then
	# erase current image from partition
	flash_erase /dev/mtd3 0 12
	#copy image to flash partition
	nandwrite -p /dev/mtd3 $FIRMWAR_UPGRADE_DIR/upgrade/ram_zimage.bin
	
	echo "successfully update Kernel"

	rm -rf $FIRMWAR_UPGRADE_DIR/upgrade/ram_zimage.bin
fi

sleep 5
#run cleanup.sh
if [ -f cleanup.sh ]
then
	chmod 755 ./cleanup.sh
	./cleanup.sh
fi
sleep 5
rm -rf $FIRMWAR_UPGRADE_DIR/*
#remove the upgrade folder from the flash

echo "successfully done reboot the system"
#reboot the system
sleep 5
reboot
